diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/model/three-gpp-channel-model.cc ns-3.36/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.35/src/spectrum/model/three-gpp-channel-model.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/model/three-gpp-channel-model.cc	2022-04-30 18:23:58.146735000 -0700
@@ -40,20 +40,18 @@
 
 NS_OBJECT_ENSURE_REGISTERED (ThreeGppChannelModel);
 
-//Table 7.5-3: Ray offset angles within a cluster, given for rms angle spread normalized to 1.
+/// The ray offset angles within a cluster, given for rms angle spread normalized to 1. (Table 7.5-3)
 static const double offSetAlpha[20] = {
-  0.0447,-0.0447,0.1413,-0.1413,0.2492,-0.2492,0.3715,-0.3715,0.5129,-0.5129,0.6797,-0.6797,0.8844,-0.8844,1.1481,-1.1481,1.5195,-1.5195,2.1551,-2.1551
-};
+  0.0447, -0.0447, 0.1413, -0.1413, 0.2492, -0.2492, 0.3715, -0.3715, 0.5129, -0.5129,
+  0.6797, -0.6797, 0.8844, -0.8844, 1.1481, -1.1481, 1.5195, -1.5195, 2.1551, -2.1551};
 
-/*
- * The cross correlation matrix is constructed according to table 7.5-6.
- * All the square root matrix is being generated using the Cholesky decomposition
- * and following the order of [SF,K,DS,ASD,ASA,ZSD,ZSA].
- * The parameter K is ignored in NLOS.
+/**
+ * The square root matrix for <em>RMa LOS</em>, which is generated using the
+ * Cholesky decomposition according to table 7.5-6 Part 2 and follows the order
+ * of [SF, K, DS, ASD, ASA, ZSD, ZSA].
  *
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
- *
  */
 static const double sqrtC_RMa_LOS[7][7] = {
   {1, 0, 0, 0, 0, 0, 0},
@@ -65,6 +63,15 @@
   {-0.17, -0.02, 0.21362, -0.14, 0.24, 0.142773, 0.909661},
 };
 
+/**
+ * The square root matrix for <em>RMa NLOS</em>, which is generated using the
+ * Cholesky decomposition according to table 7.5-6 Part 2 and follows the order
+ * of [SF, K, DS, ASD, ASA, ZSD, ZSA].
+ * The parameter K is ignored.
+ * 
+ * The Matlab file to generate the matrices can be found in
+ * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
+ */
 static const double sqrtC_RMa_NLOS[6][6] = {
   {1, 0, 0, 0, 0, 0},
   {-0.5, 0.866025, 0, 0, 0, 0},
@@ -74,6 +81,14 @@
   {-0.25, -0.606218, -0.240013, 0.26, -0.231685, 0.625392},
 };
 
+/**
+ * The square root matrix for <em>RMa O2I</em>, which is generated using the
+ * Cholesky decomposition according to table 7.5-6 Part 2 and follows the order
+ * of [SF, K, DS, ASD, ASA, ZSD, ZSA].
+ * 
+ * The Matlab file to generate the matrices can be found in
+ * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
+ */
 static const double sqrtC_RMa_O2I[6][6] = {
   {1, 0, 0, 0, 0, 0},
   {0, 1, 0, 0, 0, 0},
@@ -83,6 +98,14 @@
   {0, 0, 0.47, 0.152631, -0.393194, 0.775373},
 };
 
+/**
+ * The square root matrix for <em>UMa LOS</em>, which is generated using the
+ * Cholesky decomposition according to table 7.5-6 Part 1 and follows the order
+ * of [SF, K, DS, ASD, ASA, ZSD, ZSA].
+ *
+ * The Matlab file to generate the matrices can be found in
+ * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
+ */
 static const double sqrtC_UMa_LOS[7][7] = {
   {1, 0, 0, 0, 0, 0, 0},
   {0, 1, 0, 0, 0, 0, 0},
@@ -93,7 +116,15 @@
   {-0.8, 0, -0.388057, -0.367926, 0.238537, -3.58949e-15, 0.130931},
 };
 
-
+/**
+ * The square root matrix for <em>UMa NLOS</em>, which is generated using the
+ * Cholesky decomposition according to table 7.5-6 Part 1 and follows the order
+ * of [SF, K, DS, ASD, ASA, ZSD, ZSA].
+ * The parameter K is ignored.
+ * 
+ * The Matlab file to generate the matrices can be found in
+ * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
+ */
 static const double sqrtC_UMa_NLOS[6][6] = {
   {1, 0, 0, 0, 0, 0},
   {-0.4, 0.916515, 0, 0, 0, 0},
@@ -103,6 +134,14 @@
   {-0.4, -0.174574, -0.396459, 0.392138, 0.49099, 0.507445},
 };
 
+/**
+ * The square root matrix for <em>UMa O2I</em>, which is generated using the
+ * Cholesky decomposition according to table 7.5-6 Part 1 and follows the order
+ * of [SF, K, DS, ASD, ASA, ZSD, ZSA].
+ * 
+ * The Matlab file to generate the matrices can be found in
+ * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
+ */
 static const double sqrtC_UMa_O2I[6][6] = {
   {1, 0, 0, 0, 0, 0},
   {-0.5, 0.866025, 0, 0, 0, 0},
@@ -113,6 +152,14 @@
 
 };
 
+/**
+ * The square root matrix for <em>UMi LOS</em>, which is generated using the
+ * Cholesky decomposition according to table 7.5-6 Part 1 and follows the order
+ * of [SF, K, DS, ASD, ASA, ZSD, ZSA].
+ *
+ * The Matlab file to generate the matrices can be found in
+ * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
+ */
 static const double sqrtC_UMi_LOS[7][7] = {
   {1, 0, 0, 0, 0, 0, 0},
   {0.5, 0.866025, 0, 0, 0, 0, 0},
@@ -123,6 +170,15 @@
   {0, 0, 0.280976, 0.231921, -0.490509, 0.11916, 0.782603},
 };
 
+/**
+ * The square root matrix for <em>UMi NLOS</em>, which is generated using the
+ * Cholesky decomposition according to table 7.5-6 Part 1 and follows the order
+ * of [SF, K, DS, ASD, ASA, ZSD, ZSA].
+ * The parameter K is ignored.
+ * 
+ * The Matlab file to generate the matrices can be found in
+ * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
+ */
 static const double sqrtC_UMi_NLOS[6][6] = {
   {1, 0, 0, 0, 0, 0},
   {-0.7, 0.714143, 0, 0, 0, 0},
@@ -132,6 +188,14 @@
   {0, 0, 0.5, 0.221981, -0.566238, 0.616522},
 };
 
+/**
+ * The square root matrix for <em>UMi O2I</em>, which is generated using the
+ * Cholesky decomposition according to table 7.5-6 Part 1 and follows the order
+ * of [SF, K, DS, ASD, ASA, ZSD, ZSA].
+ * 
+ * The Matlab file to generate the matrices can be found in
+ * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
+ */
 static const double sqrtC_UMi_O2I[6][6] = {
   {1, 0, 0, 0, 0, 0},
   {-0.5, 0.866025, 0, 0, 0, 0},
@@ -141,6 +205,14 @@
   {0, -0.23094, 0.16843, 0.808554, -0.220827, 0.464515},
 };
 
+/**
+ * The square root matrix for <em>Indoor-Office LOS</em>, which is generated
+ * using the Cholesky decomposition according to table 7.5-6 Part 2 and follows
+ * the order of [SF, K, DS, ASD, ASA, ZSD, ZSA].
+ *
+ * The Matlab file to generate the matrices can be found in
+ * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
+ */
 static const double sqrtC_office_LOS[7][7] = {
   {1, 0, 0, 0, 0, 0, 0},
   {0.5, 0.866025, 0, 0, 0, 0, 0},
@@ -151,6 +223,15 @@
   {0.3, -0.057735, 0.73598, -0.348236, 0.0610847, -0.304997, 0.383375},
 };
 
+/**
+ * The square root matrix for <em>Indoor-Office NLOS</em>, which is generated
+ * using the Cholesky decomposition according to table 7.5-6 Part 2 and follows
+ * the order of [SF, K, DS, ASD, ASA, ZSD, ZSA].
+ * The parameter K is ignored.
+ * 
+ * The Matlab file to generate the matrices can be found in
+ * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
+ */
 static const double sqrtC_office_NLOS[6][6] = {
   {1, 0, 0, 0, 0, 0},
   {-0.5, 0.866025, 0, 0, 0, 0},
@@ -165,6 +246,7 @@
   NS_LOG_FUNCTION (this);
   m_uniformRv = CreateObject<UniformRandomVariable> ();
   m_uniformRvShuffle = CreateObject<UniformRandomVariable> ();
+  m_uniformRvDoppler = CreateObject<UniformRandomVariable> ();
 
   m_normalRv = CreateObject<NormalRandomVariable> ();
   m_normalRv->SetAttribute ("Mean", DoubleValue (0.0));
@@ -180,11 +262,12 @@
 ThreeGppChannelModel::DoDispose ()
 {
   NS_LOG_FUNCTION (this);
-  m_channelMap.clear ();
   if (m_channelConditionModel)
     {
       m_channelConditionModel->Dispose ();
     }
+  m_channelMatrixMap.clear ();
+  m_channelParamsMap.clear ();
   m_channelConditionModel = nullptr;
 }
 
@@ -192,7 +275,6 @@
 ThreeGppChannelModel::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::ThreeGppChannelModel")
-    .SetParent<Object> ()
     .SetGroupName ("Spectrum")
     .SetParent<MatrixBasedChannelModel> ()
     .AddConstructor<ThreeGppChannelModel> ()
@@ -240,6 +322,14 @@
                    DoubleValue (1),
                    MakeDoubleAccessor (&ThreeGppChannelModel::m_blockerSpeed),
                    MakeDoubleChecker<double> ())
+    .AddAttribute ("vScatt",
+                   "Maximum speed of the vehicle in the layout (see 3GPP TR 37.885 v15.3.0, Sec. 6.2.3)."
+                   "Used to compute the additional contribution for the Doppler of"
+                   "delayed (reflected) paths",
+                   DoubleValue (0.0),
+                   MakeDoubleAccessor (&ThreeGppChannelModel::m_vScatt),
+                   MakeDoubleChecker<double> (0.0))
+
   ;
   return tid;
 }
@@ -280,7 +370,7 @@
   NS_ASSERT_MSG (scenario == "RMa" || scenario == "UMa" || scenario == "UMi-StreetCanyon"
                  || scenario == "InH-OfficeOpen" || scenario == "InH-OfficeMixed"
                  || scenario == "V2V-Urban" || scenario == "V2V-Highway",
-                 "Unknown scenario, choose between RMa, UMa, UMi-StreetCanyon,"
+                 "Unknown scenario, choose between: RMa, UMa, UMi-StreetCanyon, "
                  "InH-OfficeOpen, InH-OfficeMixed, V2V-Urban or V2V-Highway");
   m_scenario = scenario;
 }
@@ -293,7 +383,8 @@
 }
 
 Ptr<const ThreeGppChannelModel::ParamsTable>
-ThreeGppChannelModel::GetThreeGppTable (Ptr<const ChannelCondition> channelCondition, double hBS, double hUT, double distance2D) const
+ThreeGppChannelModel::GetThreeGppTable (Ptr<const ChannelCondition> channelCondition, double hBS,
+                                        double hUT, double distance2D) const
 {
   NS_LOG_FUNCTION (this);
 
@@ -356,7 +447,7 @@
           table3gpp->m_sigLgASD = 0.45;
           table3gpp->m_uLgASA = 1.52;
           table3gpp->m_sigLgASA = 0.13;
-          table3gpp->m_uLgZSA = 0.58,
+          table3gpp->m_uLgZSA = 0.58;
           table3gpp->m_sigLgZSA = 0.37;
           table3gpp->m_uLgZSD = std::max (-1.0, -0.19 * (distance2D / 1000) - 0.01 * (hUT - 1.5) + 0.28);
           table3gpp->m_sigLgZSD = 0.30;
@@ -390,7 +481,7 @@
           table3gpp->m_sigLgASD = 0.18;
           table3gpp->m_uLgASA = 1.66;
           table3gpp->m_sigLgASA = 0.21;
-          table3gpp->m_uLgZSA = 0.93,
+          table3gpp->m_uLgZSA = 0.93;
           table3gpp->m_sigLgZSA = 0.22;
           table3gpp->m_uLgZSD = std::max (-1.0, -0.19 * (distance2D / 1000) - 0.01 * (hUT - 1.5) + 0.28);
           table3gpp->m_sigLgZSD = 0.30;
@@ -460,7 +551,7 @@
           double cfc = -0.13 * log10 (fcGHz) + 2.03;
           double efc = 7.66 * log10 (fcGHz) - 5.96;
 
-          double offsetZOD = efc - std::pow (10, afc * log10 (std::max (bfc,distance2D)) + cfc);
+          double offsetZOD = efc - std::pow (10, afc * log10 (std::max (bfc, distance2D)) + cfc);
 
           if (!los && !o2i)
             {
@@ -573,7 +664,7 @@
         }
       else
         {
-          double uLgZSD = std::max (-0.5, -3.1 * distance2D / 1000 + 0.01 * std::max (hUT - hBS,0.0) + 0.2);
+          double uLgZSD = std::max (-0.5, -3.1 * distance2D / 1000 + 0.01 * std::max (hUT - hBS, 0.0) + 0.2);
           double offsetZOD = -1 * std::pow (10, -1.5 * log10 (std::max (10.0, distance2D)) + 3.3);
           if (!los && !o2i)
             {
@@ -645,7 +736,7 @@
             }
         }
     }
-  else if (m_scenario == "InH-OfficeMixed"||m_scenario == "InH-OfficeOpen")
+  else if (m_scenario == "InH-OfficeMixed" || m_scenario == "InH-OfficeOpen")
     {
       NS_ASSERT_MSG (!o2i, "The indoor scenario does out support outdoor to indoor");
       if (los)
@@ -731,8 +822,8 @@
           table3gpp->m_sigLgASD = 0.1;
           table3gpp->m_uLgASA = -0.1 * log10 (1 + fcGHz) + 1.6;
           table3gpp->m_sigLgASA = 0.1;
-          table3gpp->m_uLgZSA = -0.1 * log10 (1 + fcGHz) + 0.73,
-          table3gpp->m_sigLgZSA = -0.04 * log10 (1 + fcGHz) + 0.34,
+          table3gpp->m_uLgZSA = -0.1 * log10 (1 + fcGHz) + 0.73;
+          table3gpp->m_sigLgZSA = -0.04 * log10 (1 + fcGHz) + 0.34;
           table3gpp->m_uLgZSD = -0.1 * log10 (1 + fcGHz) + 0.73;
           table3gpp->m_sigLgZSD = -0.04 * log10 (1 + fcGHz) + 0.34;
           table3gpp->m_offsetZOD = 0;
@@ -765,7 +856,7 @@
           table3gpp->m_sigLgASD = 0.05 * log10 (1 + fcGHz) + 0.3;
           table3gpp->m_uLgASA = -0.08 * log10 (1 + fcGHz) + 1.81;
           table3gpp->m_sigLgASA = 0.05 * log10 (1 + fcGHz) + 0.3;
-          table3gpp->m_uLgZSA = -0.04 * log10 (1 + fcGHz) + 0.92,
+          table3gpp->m_uLgZSA = -0.04 * log10 (1 + fcGHz) + 0.92;
           table3gpp->m_sigLgZSA = -0.07 * log10 (1 + fcGHz) + 0.41;
           table3gpp->m_uLgZSD = -0.04 * log10 (1 + fcGHz) + 0.92;
           table3gpp->m_sigLgZSD = -0.07 * log10 (1 + fcGHz) + 0.41;
@@ -910,7 +1001,7 @@
           table3gpp->m_sigLgASD = 0.05 * log10 (1 + fcGHz) + 0.3;
           table3gpp->m_uLgASA = -0.08 * log10 (1 + fcGHz) + 1.81;
           table3gpp->m_sigLgASA = 0.05 * log10 (1 + fcGHz) + 0.3;
-          table3gpp->m_uLgZSA = -0.04 * log10 (1 + fcGHz) + 0.92,
+          table3gpp->m_uLgZSA = -0.04 * log10 (1 + fcGHz) + 0.92;
           table3gpp->m_sigLgZSA = -0.07 * log10 (1 + fcGHz) + 0.41;
           table3gpp->m_uLgZSD = -0.04 * log10 (1 + fcGHz) + 0.92;
           table3gpp->m_sigLgZSD = -0.07 * log10 (1 + fcGHz) + 0.41;
@@ -948,29 +1039,45 @@
 }
 
 bool
-ThreeGppChannelModel::ChannelMatrixNeedsUpdate (Ptr<const ThreeGppChannelMatrix> channelMatrix, Ptr<const ChannelCondition> channelCondition) const
+ThreeGppChannelModel::ChannelParamsNeedsUpdate (Ptr<const ThreeGppChannelParams> channelParams,
+                                                Ptr<const ChannelCondition> channelCondition) const
 {
   NS_LOG_FUNCTION (this);
 
   bool update = false;
 
   // if the channel condition is different the channel has to be updated
-  if (!channelMatrix->m_channelCondition->IsEqual (channelCondition))
+  if (!channelCondition->IsEqual (channelParams->m_losCondition, channelParams->m_o2iCondition))
     {
       NS_LOG_DEBUG ("Update the channel condition");
       update = true;
     }
 
   // if the coherence time is over the channel has to be updated
-  if (!m_updatePeriod.IsZero () && Simulator::Now () - channelMatrix->m_generatedTime > m_updatePeriod)
+  if (!m_updatePeriod.IsZero () && Simulator::Now () - channelParams->m_generatedTime > m_updatePeriod)
     {
-      NS_LOG_DEBUG ("Generation time " << channelMatrix->m_generatedTime.As (Time::NS) << " now " << Now ().As (Time::NS));
+      NS_LOG_DEBUG ("Generation time " << channelParams->m_generatedTime.As (Time::NS) << " now " << Now ().As (Time::NS));
       update = true;
     }
 
   return update;
 }
 
+
+bool
+ThreeGppChannelModel::ChannelMatrixNeedsUpdate (Ptr<const ThreeGppChannelParams> channelParams, Ptr<const ChannelMatrix> channelMatrix)
+{
+
+  if (channelParams->m_generatedTime > channelMatrix->m_generatedTime)
+    {
+      return true;
+    }
+  else
+    {
+      return false;
+    }
+}
+
 Ptr<const MatrixBasedChannelModel::ChannelMatrix>
 ThreeGppChannelModel::GetChannel (Ptr<const MobilityModel> aMob,
                                   Ptr<const MobilityModel> bMob,
@@ -979,107 +1086,135 @@
 {
   NS_LOG_FUNCTION (this);
 
-  // Compute the channel key. The key is reciprocal, i.e., key (a, b) = key (b, a)
-  uint32_t x1 = std::min (aMob->GetObject<Node> ()->GetId (), bMob->GetObject<Node> ()->GetId ());
-  uint32_t x2 = std::max (aMob->GetObject<Node> ()->GetId (), bMob->GetObject<Node> ()->GetId ());
-  uint32_t channelId = GetKey (x1, x2);
+  // Compute the channel params key. The key is reciprocal, i.e., key (a, b) = key (b, a)
+  uint64_t channelParamsKey = GetKey (aMob->GetObject<Node> ()->GetId (), bMob->GetObject<Node> ()->GetId ());
+  // Compute the channel matrix key. The key is reciprocal, i.e., key (a, b) = key (b, a)
+  uint64_t channelMatrixKey = GetKey (aAntenna->GetId (), bAntenna->GetId ());
 
   // retrieve the channel condition
   Ptr<const ChannelCondition> condition = m_channelConditionModel->GetChannelCondition (aMob, bMob);
 
   // Check if the channel is present in the map and return it, otherwise
   // generate a new channel
-  bool update = false;
-  bool notFound = false;
-  Ptr<ThreeGppChannelMatrix> channelMatrix;
-  if (m_channelMap.find (channelId) != m_channelMap.end ())
+  bool updateParams = false;
+  bool updateMatrix = false;
+  bool notFoundParams = false;
+  bool notFoundMatrix = false;
+  Ptr<ChannelMatrix> channelMatrix;
+  Ptr<ThreeGppChannelParams> channelParams;
+
+
+  if (m_channelParamsMap.find (channelParamsKey) != m_channelParamsMap.end ())
+    {
+      channelParams = m_channelParamsMap[channelParamsKey];
+      // check if it has to be updated
+      updateParams = ChannelParamsNeedsUpdate (channelParams, condition);
+    }
+  else
+    {
+      NS_LOG_DEBUG ("channel params not found");
+      notFoundParams = true;
+    }
+
+  double x = aMob->GetPosition ().x - bMob->GetPosition ().x;
+  double y = aMob->GetPosition ().y - bMob->GetPosition ().y;
+  double distance2D = sqrt (x * x + y * y);
+
+  // NOTE we assume hUT = min (height(a), height(b)) and
+  // hBS = max (height (a), height (b))
+  double hUt = std::min (aMob->GetPosition ().z, bMob->GetPosition ().z);
+  double hBs = std::max (aMob->GetPosition ().z, bMob->GetPosition ().z);
+
+  // get the 3GPP parameters
+  Ptr<const ParamsTable> table3gpp = GetThreeGppTable (condition, hBs, hUt, distance2D);
+
+  if (notFoundParams || updateParams)
+    {
+      //Step 4: Generate large scale parameters. All LSPS are uncorrelated.
+      //Step 5: Generate Delays.
+      //Step 6: Generate cluster powers.
+      //Step 7: Generate arrival and departure angles for both azimuth and elevation.
+      //Step 8: Coupling of rays within a cluster for both azimuth and elevation
+      //shuffle all the arrays to perform random coupling
+      //Step 9: Generate the cross polarization power ratios
+      //Step 10: Draw initial phases
+      channelParams = GenerateChannelParameters (condition, table3gpp, aMob, bMob);
+      // store or replace the channel parameters
+      m_channelParamsMap[channelParamsKey] = channelParams;
+    }
+
+  if (m_channelMatrixMap.find (channelMatrixKey) != m_channelMatrixMap.end ())
     {
       // channel matrix present in the map
       NS_LOG_DEBUG ("channel matrix present in the map");
-      channelMatrix = m_channelMap[channelId];
-
-      // check if it has to be updated
-      update = ChannelMatrixNeedsUpdate (channelMatrix, condition);
+      channelMatrix = m_channelMatrixMap[channelMatrixKey];
+      updateMatrix = ChannelMatrixNeedsUpdate (channelParams, channelMatrix);
     }
   else
     {
       NS_LOG_DEBUG ("channel matrix not found");
-      notFound = true;
+      notFoundMatrix = true;
     }
 
   // If the channel is not present in the map or if it has to be updated
   // generate a new realization
-  if (notFound || update)
+  if (notFoundMatrix || updateMatrix)
     {
       // channel matrix not found or has to be updated, generate a new one
-      Angles txAngle (bMob->GetPosition (), aMob->GetPosition ());
-      Angles rxAngle (aMob->GetPosition (), bMob->GetPosition ());
-
-      double x = aMob->GetPosition ().x - bMob->GetPosition ().x;
-      double y = aMob->GetPosition ().y - bMob->GetPosition ().y;
-      double distance2D = sqrt (x * x + y * y);
-
-      // NOTE we assume hUT = min (height(a), height(b)) and
-      // hBS = max (height (a), height (b))
-      double hUt = std::min (aMob->GetPosition ().z, bMob->GetPosition ().z);
-      double hBs = std::max (aMob->GetPosition ().z, bMob->GetPosition ().z);
-
-      // TODO this is not currently used, it is needed for the computation of the
-      // additional blockage in case of spatial consistent update
-      // I do not know who is the UT, I can use the relative distance between
-      // tx and rx instead
-      Vector locUt = Vector (0.0, 0.0, 0.0);
-
-      channelMatrix = GetNewChannel (locUt, condition, aAntenna, bAntenna, rxAngle, txAngle, distance2D, hBs, hUt);
-      channelMatrix->m_nodeIds = std::make_pair (aMob->GetObject<Node> ()->GetId (), bMob->GetObject<Node> ()->GetId ());
+      channelMatrix = GetNewChannel (channelParams, table3gpp, aMob, bMob, aAntenna, bAntenna);
+      channelMatrix->m_antennaPair = std::make_pair (aAntenna->GetId (), bAntenna->GetId ()); // save antenna pair, with the exact order of s and u antennas at the moment of the channel generation
 
       // store or replace the channel matrix in the channel map
-      m_channelMap[channelId] = channelMatrix;
+      m_channelMatrixMap[channelMatrixKey] = channelMatrix;
     }
 
   return channelMatrix;
 }
 
-Ptr<ThreeGppChannelModel::ThreeGppChannelMatrix>
-ThreeGppChannelModel::GetNewChannel (Vector locUT, Ptr<const ChannelCondition> channelCondition,
-                                     Ptr<const PhasedArrayModel> sAntenna,
-                                     Ptr<const PhasedArrayModel> uAntenna,
-                                     Angles &uAngle, Angles &sAngle,
-                                     double dis2D, double hBS, double hUT) const
+Ptr<const MatrixBasedChannelModel::ChannelParams>
+ThreeGppChannelModel::GetParams (Ptr<const MobilityModel> aMob,
+                                 Ptr<const MobilityModel> bMob) const
 {
   NS_LOG_FUNCTION (this);
 
-  NS_ASSERT_MSG (m_frequency > 0.0, "Set the operating frequency first!");
+  // Compute the channel key. The key is reciprocal, i.e., key (a, b) = key (b, a)
+  uint64_t channelParamsKey = GetKey (aMob->GetObject<Node> ()->GetId (), bMob->GetObject<Node> ()->GetId ());
 
-  // get the 3GPP parameters
-  Ptr<const ParamsTable> table3gpp = GetThreeGppTable (channelCondition, hBS, hUT, dis2D);
+  if (m_channelParamsMap.find (channelParamsKey) != m_channelParamsMap.end ())
+    {
+      return m_channelParamsMap.find (channelParamsKey)->second;
+    }
+  else
+    {
+      NS_LOG_WARN ("Channel params map not found. Returning a nullptr.");
+      return nullptr;
+    }
+}
 
-  // get the number of clusters and the number of rays per cluster
-  uint8_t numOfCluster = table3gpp->m_numOfCluster;
-  uint8_t raysPerCluster = table3gpp->m_raysPerCluster;
 
+Ptr<ThreeGppChannelModel::ThreeGppChannelParams>
+ThreeGppChannelModel::GenerateChannelParameters (const Ptr<const ChannelCondition> channelCondition,
+                                                 const Ptr<const ParamsTable> table3gpp,
+                                                 const Ptr<const MobilityModel> aMob,
+                                                 const Ptr<const MobilityModel> bMob) const
+{
+
+  NS_LOG_FUNCTION (this);
   // create a channel matrix instance
-  Ptr<ThreeGppChannelMatrix> channelParams = Create<ThreeGppChannelMatrix> ();
-  channelParams->m_channelCondition = channelCondition; // set the channel condition
+  Ptr<ThreeGppChannelParams> channelParams = Create<ThreeGppChannelParams> ();
   channelParams->m_generatedTime = Simulator::Now ();
-
-  // compute the 3D distance using eq. 7.4-1
-  double dis3D = std::sqrt (dis2D * dis2D + (hBS - hUT) * (hBS - hUT));
-
-  bool los = channelCondition->IsLos ();
-  bool o2i = channelCondition->IsO2i ();
+  channelParams->m_nodeIds = std::make_pair (aMob->GetObject<Node> ()->GetId (), bMob->GetObject<Node> ()->GetId ());
+  channelParams->m_losCondition = channelCondition->GetLosCondition ();
+  channelParams->m_o2iCondition = channelCondition->GetO2iCondition ();
 
   //Step 4: Generate large scale parameters. All LSPS are uncorrelated.
   DoubleVector LSPsIndep, LSPs;
-  uint8_t paramNum;
-  if (los)
+  uint8_t paramNum = 6;
+  if (channelParams->m_losCondition == ChannelCondition::LOS)
     {
       paramNum = 7;
     }
-  else
-    {
-      paramNum = 6;
-    }
+
   //Generate paramNum independent LSPs.
   for (uint8_t iter = 0; iter < paramNum; iter++)
     {
@@ -1096,11 +1231,10 @@
     }
 
   // NOTE the shadowing is generated in the propagation loss model
-
-  double DS,ASD,ASA,ZSA,ZSD,K_factor = 0;
-  if (los)
+  double DS, ASD, ASA, ZSA, ZSD, kFactor = 0;
+  if (channelParams->m_losCondition == ChannelCondition::LOS)
     {
-      K_factor = LSPs[1] * table3gpp->m_sigK + table3gpp->m_uK;
+      kFactor = LSPs[1] * table3gpp->m_sigK + table3gpp->m_uK;
       DS = pow (10, LSPs[2] * table3gpp->m_sigLgDS + table3gpp->m_uLgDS);
       ASD = pow (10, LSPs[3] * table3gpp->m_sigLgASD + table3gpp->m_uLgASD);
       ASA = pow (10, LSPs[4] * table3gpp->m_sigLgASA + table3gpp->m_uLgASA);
@@ -1121,17 +1255,19 @@
   ZSD = std::min (ZSD, 52.0);
   ZSA = std::min (ZSA, 52.0);
 
+  // save DS and K_factor parameters in the structure
   channelParams->m_DS = DS;
-  channelParams->m_K = K_factor;
+  channelParams->m_K_factor = kFactor;
 
-  NS_LOG_INFO ("K-factor=" << K_factor << ",DS=" << DS << ", ASD=" << ASD << ", ASA=" << ASA << ", ZSD=" << ZSD << ", ZSA=" << ZSA);
+  NS_LOG_INFO ("K-factor=" << kFactor << ", DS=" << DS << ", ASD=" << ASD << ", ASA=" << ASA
+                           << ", ZSD=" << ZSD << ", ZSA=" << ZSA);
 
   //Step 5: Generate Delays.
   DoubleVector clusterDelay;
   double minTau = 100.0;
-  for (uint8_t cIndex = 0; cIndex < numOfCluster; cIndex++)
+  for (uint8_t cIndex = 0; cIndex < table3gpp->m_numOfCluster; cIndex++)
     {
-      double tau = -1 * table3gpp->m_rTau * DS * log (m_uniformRv->GetValue (0,1)); //(7.5-1)
+      double tau = -1 * table3gpp->m_rTau * DS * log (m_uniformRv->GetValue (0, 1)); //(7.5-1)
       if (minTau > tau)
         {
           minTau = tau;
@@ -1139,7 +1275,7 @@
       clusterDelay.push_back (tau);
     }
 
-  for (uint8_t cIndex = 0; cIndex < numOfCluster; cIndex++)
+  for (uint8_t cIndex = 0; cIndex < table3gpp->m_numOfCluster; cIndex++)
     {
       clusterDelay[cIndex] -= minTau;
     }
@@ -1151,34 +1287,37 @@
   //Step 6: Generate cluster powers.
   DoubleVector clusterPower;
   double powerSum = 0;
-  for (uint8_t cIndex = 0; cIndex < numOfCluster; cIndex++)
+  for (uint8_t cIndex = 0; cIndex < table3gpp->m_numOfCluster; cIndex++)
     {
       double power = exp (-1 * clusterDelay[cIndex] * (table3gpp->m_rTau - 1) / table3gpp->m_rTau / DS) *
-        pow (10,-1 * m_normalRv->GetValue () * table3gpp->m_perClusterShadowingStd / 10);                       //(7.5-5)
+        pow (10, -1 * m_normalRv->GetValue () * table3gpp->m_perClusterShadowingStd / 10);                       //(7.5-5)
       powerSum += power;
       clusterPower.push_back (power);
     }
+  channelParams->m_clusterPower = clusterPower;
+
   double powerMax = 0;
 
-  for (uint8_t cIndex = 0; cIndex < numOfCluster; cIndex++)
+  for (uint8_t cIndex = 0; cIndex < table3gpp->m_numOfCluster; cIndex++)
     {
-      clusterPower[cIndex] = clusterPower[cIndex] / powerSum; //(7.5-6)
+      channelParams->m_clusterPower[cIndex] = channelParams->m_clusterPower[cIndex] / powerSum; //(7.5-6)
     }
 
   DoubleVector clusterPowerForAngles; // this power is only for equation (7.5-9) and (7.5-14), not for (7.5-22)
-  if (los)
+  if (channelParams->m_losCondition == ChannelCondition::LOS)
     {
-      double K_linear = pow (10,K_factor / 10);
+      double kLinear = pow (10, kFactor / 10);
 
-      for (uint8_t cIndex = 0; cIndex < numOfCluster; cIndex++)
+      for (uint8_t cIndex = 0; cIndex < table3gpp->m_numOfCluster; cIndex++)
         {
           if (cIndex == 0)
             {
-              clusterPowerForAngles.push_back (clusterPower[cIndex] / (1 + K_linear) + K_linear / (1 + K_linear));                  //(7.5-8)
+              clusterPowerForAngles.push_back (channelParams->m_clusterPower[cIndex] / (1 + kLinear) +
+                                               kLinear / (1 + kLinear));                  //(7.5-8)
             }
           else
             {
-              clusterPowerForAngles.push_back (clusterPower[cIndex] / (1 + K_linear)); //(7.5-8)
+              clusterPowerForAngles.push_back (channelParams->m_clusterPower[cIndex] / (1 + kLinear)); //(7.5-8)
             }
           if (powerMax < clusterPowerForAngles[cIndex])
             {
@@ -1188,9 +1327,9 @@
     }
   else
     {
-      for (uint8_t cIndex = 0; cIndex < numOfCluster; cIndex++)
+      for (uint8_t cIndex = 0; cIndex < table3gpp->m_numOfCluster; cIndex++)
         {
-          clusterPowerForAngles.push_back (clusterPower[cIndex]); //(7.5-6)
+          clusterPowerForAngles.push_back (channelParams->m_clusterPower[cIndex]); //(7.5-6)
           if (powerMax < clusterPowerForAngles[cIndex])
             {
               powerMax = clusterPowerForAngles[cIndex];
